#ifndef HARKIO_HARK_WRITABLE_HPP_
#define HARKIO_HARK_WRITABLE_HPP_

#include <harkio2/InvalidHarkFile.hpp>

/** @file Writable.hpp
 * @brief Writableインターフェースの定義
 */

namespace harkio2
{
namespace hark
{

class HarkFileWriter;

/** @brief Writableインターフェース
 *
 * ファイルに書き出され得るデータ構造（DataSet, Fmt1_0, Spec1_0など）
 * はこのインターフェースを実装しなければならない。
 */
class Writable
{
public:
    /// @brief 継承のための仮想デストラクタ
    virtual ~Writable() {}

    /** @brief データ構造を指定されたライターを使って書き出す。
     * @param writer ライターオブジェクト
     */
    virtual void Write(HarkFileWriter& writer) throw (harkio2::InvalidHarkFile) = 0;
};

}
}

#endif // HARKIO_HARK_WRITABLE_HPP_

